;assemble with  $>  nasmw -fobj bignum.asm
; link with     $>  alink -c -oPE -subsys gui bignum
;
%include "nagoa+.inc"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%include "bignummac.inc"      ;;;our macros
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

%macro API 2                                   ;Function , Library
	import %1 %2
	extern %1
%endmacro

API ExitProcess, kernel32.dll
API MessageBoxA, user32.dll

section .data 

stringno db "1234",0
outputbuffer : times SIZE_BIGNUM db 0

section .code class=code use32

..start:

BIGNUM anum,bnum,cnum,dnum          ; declare variables anum and bnum

movBIGNUM anum,"555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555555" 
movBIGNUM bnum,"555555555555555555555555555555555555555555555555555555555555555555555555"    

divBIGNUM cnum,dnum,anum,bnum

BIGNUM2str cnum,outputbuffer                      ;itoa(cnum,outputbuffer,10)
call MessageBoxA,0,outputbuffer,"hi",0            ; printing quotient.

BIGNUM2str dnum,outputbuffer                      ;itoa(dnum,outputbuffer,10)
call MessageBoxA,0,outputbuffer,"hi",0            ; printing remainder

str2BIGNUM anum,stringno

addBIGNUM anum,"4321"

BIGNUM2str anum,outputbuffer                      ;itoa(dnum,outputbuffer,10)
call MessageBoxA,0,outputbuffer,"hi",0            ; printing output

call ExitProcess,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%include "bignumproc.inc"  ;;; our procedures
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;